#include <stdlib.h>
#include <iostream.h>
#include <iomanip.h>
#include "Fint.hpp"
#include "CPUTime.hpp"
#include "MintFunc.hpp"

Fint Chudnovsky(long precision)
{
  long prec=SetPrecision(precision) ;
  Fint p ;
 // unsigned long c(640320),m ;
  unsigned long m ;
  long c(-320160L) ;
//  unsigned long d(545140134) ;

  unsigned long j ;
  Mint n6(1) ;
  Mint n3(1) ;
  Mint n1(1) ;
  Mint cn(1) ;
  Mint c3(1) ;
  Mint n(1) ;
  Mint c2("6541681608") ;

  Fint a(13591409) ;
  a /= 545140134UL ;
  Fint d(1) ;
  ((c3 *= c) *= c ) *= c ;
  p=a ;
  for( j=1 ;; j++) {
    a++ ;
    m=6*j ;
    d *= (m-1) ;
    d *= (m-3) ;
    d *= (m-5) ;
    d /= (c3*j*j*j) ;
    if( d==0 ) break ;
    p += a*d ;
/*************
    a++ ;
    n=j ;
    n1 *=  n*n*n ;
    n *= 3 ;
    n3 *= n*(n-1)*(n-2) ;
    n *= 2 ;
    n6 *= n*(n-1)*(n-2)*(n-3)*(n-4)*(n-5) ;
    cn *= c3 ;
    d = n6 ;
    d /= (n3*n1*cn) ;
    if( d==0 ) break ;
    p -= a*d ;

    a++ ;
    ++j ;
    n=j ;
    n1 *=  n*n*n ;
    n *= 3  ;
    n3 *= n*(n-1)*(n-2) ;
    n *= 2 ;
    n6 *= n*(n-1)*(n-2)*(n-3)*(n-4)*(n-5) ;
    cn *= c3 ;
    d = n6 ;

    d /= (n3*n1*cn) ;
    if( d==0 ) break ;
    p += a*d ;
***************/

  }
  cout << endl << "j " << j ;

  Fint f(-8*c3) ;
  f=sqrt(f) ;
  p=f/p/c2  ;

  SetPrecision(prec) ;
  return p ;
}

int main(void)
{
  SetFormat(digit5) ;
  SetPrecision(1) ;
  Fint _pi ;
  CPUTime cputime,cpu ;
  long precision ;

  for(;;) {
    cout << endl << " Input precision (Input 0 to exit) " ;
    cin >> precision ;
    if( precision<=0 ) break ;
    precision=double(precision)/(4*2.40824)+1 ;
    if( precision==0 ) precision=1 ;
    cputime.Start() ;
    _pi=Chudnovsky(precision) ;
    cputime.Stop() ;
    cout << endl << _pi ;
    cout << endl << "cputime " << cputime ;
    cputime.Reset() ;
cout << endl << precision ;
  }
RET: ;
  return 0 ;
}
