//
//  Copyright (C) by S.Tomabechi 1994
//  All rights reserved.
//
//  Algorithm 2.2.1 ( Square Linear System)
//  Let M be an n*n matrix. This Algorithm either outputs a message
//  saying that M is not invertible, or outputs the inverse of M.
//  We use an auxiliary column vector C .
//

#include "Matrix.hpp"

#define TRUE 1
#define FALSE 0
/****

template<class T>
inline void Swap(T& a,T& b)
{
  T w ;
  w=a ;
  a=b ;
  b=w ;
}
****/

template<class T>
int InvMat(Matrix<T>& m)
{

  int i,j,k,l ;
//  Vector<T> c(m.ncol()) ;
  T* c=new T[m.ncol()] ;
  Matrix<T> b(m.nrow(),m.ncol()) ;
  T d ;

Initilalize:
  for( j=0 ; j<m.nrow() ; j++ ) {
    for( k=0 ; k<m.ncol() ; k++ ) b(j,k)=0 ;
    b(j,j)=1 ;
  }

cout << endl << b ;

Finishd:
  for( j=0 ; j<m.ncol() ; j++ ) {
Find_nonzero_entry:
    for( k=j ; k<m.nrow() ; k++ ) {
      if( m(k,j)!=0 ) break ;
    }
    if( k>=m.nrow() ) return  FALSE ; // m is not invertible
Swap:
    if( k>j ) {
      for( l=0 ; l<b.ncol() ; l++ ) {
        Swap(m(k,l),m(j,l)) ;
        Swap(b(k,l),b(j,l)) ;
      }
    }
Eliminate:
    d=1/m(j,j) ;
    for( k=j+1 ; k<m.nrow() ; k++ ) c[k]=d*m(k,j) ;
    for( k=j+1 ; k<m.nrow() ; k++ ) {
      for( l=j+1 ; l<m.ncol() ; l++ )
        m(k,l) -= c[k]*m(j,l) ;
    }

    for( k=j+1 ; k<m.nrow() ; k++ ) {
      for( l=0 ; l<m.ncol() ; l++ )
        b(k,l) -= c[k]*b(j,l) ;
    }
  }

cout << endl << m ;
Solve_triangular_system:
  for( j=m.nrow()-1 ; j>=0 ; j-- ) {
    for( l=0 ; l<m.ncol() ; l++ ) {
      for( k=j+1 ; k<m.ncol() ; k++ ) {
cout << endl << j << ' ' << k << " " << l ;
cout << endl << m(j,k) << " " << b(k,l) ;
         b(j,l) -= m(j,k)*b(k,l) ;
       }
      b(j,l) /= m(j,j) ;
    }

  }
  m=b ;
  delete [] c ;
  return TRUE ;
}
