//
//  prototype of functions using class Mint
//
//   ؿץȥ
//
//  Copyright (C) by S.Tomabechi 1993-1997
//  All rights reseved.
//
#ifndef __MINTFUNC_HPP
#define __MINTFUNC_HPP
//#include <vector>
//using namespace std ;

class Mint ;
#include "IntFuncs.hpp"
#include "Bit.hpp"


extern bool display_rho ;

//Mint amod(const Mint& n,const Mint& p) ;           // ͺǾ;

Mint gcd(const Mint& a,const Mint& b) ;     // greatest common divisor
                                            // 

Mint ecm(const Mint& N,int itry=2,unsigned long maxL1=1000000UL) ;      // prime decomposition by ECM (Lenstra)
                                            // ʱ߶ˡˤǰʬ

Mint egcd(const Mint& a,const Mint& b,Mint& u,Mint& v) ;   // extended greatest common divisor
                                // ĥ

Mint xgcd(const Mint& a,const Mint& b,Mint& u,Mint& v) ;   // same as above
                              // ĥ UBSIC ȤθߴȤ뤿
Mint Combination(const unsigned long n,const unsigned long k) ;  // #combinations
                                        // ȹ礻ο

Mint invmodp(const Mint& a,const Mint& p) ;  // inverse a^(-1) mod p
inline unsigned long invmodp(const Mint& a,const unsigned long p)
{
    return invmodp(mod(a,p),p) ;
}
   // p ˡȤ a εտ  ; Z/(p)
   // ˤ a ξˡ˴ؤո
long Kronecker(const Mint& a,const Mint& p) ;
long Kronecker(const Mint& a,const long p) ;

long len10(const Mint& n) ;     // length as decimal number
                                // 10ʿȤƤη
int ndigit(const Mint& a) ;
unsigned long prmdiv(const Mint& n,
                     const unsigned long MaxDivisor=SMALL_DIVISOR) ;

Mint cyc_num(unsigned long d,long x) ; // cyclotomic number
    // ʬ׻ d=deg(\phi) return \phi(x)

Mint PPMPQS(const Mint& N) ;       // ʣ¿༰դ뤤ˡˤǰʬ
Mint rho(const Mint& N,int nLoop=100,int c=1) ;
bool APR(const Mint& N) ;              // primality test by Gauss sum (APR)
bool APRCL(const Mint& N) ;            // primality test by Jacobi sum (APR-CL)
Mint p_1(const Mint& N,const unsigned long B=SMALL_DIVISOR) ; // p_1 ˡˤǰʬ


Mint isqrt(const Mint& n) ;            // ʿʬ
Mint icubrt(const Mint& n) ;           // 躬ʬ
long ilog2(const Mint& n) ;
Mint lcm(const Mint& a,const Mint& b) ;      // least common multiple
//long mod(Mint& n,long p) ;
//unsigned long mod(Mint& n,unsigned long p) ;


// Lucas U(n),V(n) ׻
void LucasSequence(const Mint& P,const Mint& Q,
                   unsigned long n,Mint& U,Mint& V) ;
int LucasTest(const Mint& N) ;                   // LucasȤäǿȽ
Mint primorial(const unsigned long p) ;

Mint power(const Mint& x,const Mint& n,const Mint& p) ;   // x^n mod p
Mint apower(const Mint& x,const Mint& n,const Mint& p) ;  // x^n mod p
Mint power(const int x,const Mint& n,const Mint& p) ;
//Mint power(const Mint x,const Mint n) ;             // x^n
Mint power(const Mint& x, unsigned long n) ;

inline Mint power(const Mint& x,  long n)
{
    return power(x, (unsigned long)n) ;
}
inline Mint power(const Mint& x,int n)
{
    return power(x, (long)n) ;
}
Mint power(const long x,const unsigned long n) ;
Mint power(const int x,const unsigned long n) ;
Mint power(const unsigned long x,const unsigned long n) ;
Mint power(const long x,const long n) ;
int Proth(const Mint& N) ;          // Proth ˤǿȽ

int sign(const Mint& n) ;           // 
Mint square(const Mint& a) ;
int sgn(const Mint& n) ;            // same as above

Mint factorial(unsigned long n) ;    // factorial 
Mint old_factorial(unsigned long n) ;    // factorial 
Mint parse(const char* exp) ; // parser
Mint pfactorial(unsigned long a,unsigned long b,unsigned long ndiv=1<<8) ;
Mint qfactorial(unsigned long a,unsigned long b,unsigned long ndiv=1<<8) ;
bool powerdetect(const Mint& n,Mint& p,unsigned long& e) ;


// square root mod p (p ˡȤʿ
Mint sqrt(const Mint& a,const Mint& p) ;
long sqrt(const Mint& a,const long p) ;
unsigned long sqrt(const Mint& a,const unsigned long p) ;

Mint SquareTest(const Mint& n) ;
inline Mint issquare(const Mint& n)
{
    return SquareTest(n) ;
}


void Swap(Mint& a,Mint& b) ;        // ͤθ
inline void swap(Mint& a,Mint& b)
{
  Swap(a,b) ;
}
unsigned long irandom(unsigned long& n) ;    // (ɤ)
Mint& irandom(Mint& s,const Mint& n) ;

bool Rabin(const Mint& N,unsigned long maxloop=20) ; // Rabin-Miller primality test
                            // retrun value is false when N is composite
                            // return value is true when N maybe prime


inline unsigned long gcd(const Mint& m,const unsigned long n)
{
  return gcd((const unsigned long)m%n,n) ;         // assumed n!=0
}

inline unsigned long gcd(const unsigned long m,const Mint& n)
{
  return gcd(n,m) ;
}

inline long gcd(const Mint& m,const long n)
{
  return gcd((const long)m%n,n) ;                  // assumed n!=0
}

inline long gcd(const long m,const Mint& n)
{
  return gcd(n,m) ;
}
inline Mint xgcd(const Mint& a,const Mint& b,Mint& u,Mint& v)
{
  return egcd(a,b,u,v) ;
}

inline long Kronecker(const Mint& a,const long p)
{
  return Kronecker(a%p,p) ;
}

inline long Kronecker(const Mint& a,const unsigned long p)
{
  return Kronecker(a&p,p) ;
}

inline Mint max(const Mint& a,const Mint& b)      // 
{
  return a>=b ? a:b ;
}

inline Mint min(const Mint& a,const Mint& b)     // Ǿ
{
  return a<=b ? a:b ;
}

inline bool Even(const Mint& n)      // integer is even ?
{
  return n.isEven() ;
}

inline bool Odd(const Mint& n)      //integer is odd ?
{
  return n.isOdd() ;
}


inline Mint power(const Mint& x,const Mint& n,const Mint& p)
{
  return Mint::_Mtemp.power(x,n,p) ;
}

inline Mint power(const long x,const Mint& n,const Mint& p)
{
  return power(Mint::_Mtemp=x,n,p)  ;
}

inline Mint power(const int x,const Mint& n,const Mint& p)
{
    return power(long(x),n,p) ;
}

inline Mint power(const long x, unsigned long n)
{
  return power(Mint::_Mtemp=x,n) ;
}

// n ΤȤϤǤɤʤ
inline Mint power(const long x, int n)
{
  return power(Mint::_Mtemp=x,n) ;
}

inline Mint power(const long x,long n)
{
  return power(Mint::_Mtemp=x,n) ;
}

inline Mint power(const int x,unsigned long n)
{
  return power(Mint::_Mtemp=x,n) ;
}

inline Mint power(const unsigned long x,unsigned long n)
{
  return power(Mint::_Mtemp=x,n) ;
}

inline Mint power(const unsigned long x,long n)
{
  return power(Mint::_Mtemp=x,n) ;
}

inline Mint power(const unsigned long x,int n)
{
  return power(Mint::_Mtemp=x,long(n)) ;
}

inline Mint power(const int x,long n)
{
  return power(Mint::_Mtemp=x,n) ;
}

inline Mint power(const int x,int n)
{
  return power(Mint::_Mtemp=x,long(n)) ;
}

inline Mint apower(const Mint& x,const Mint& n,const Mint& p)
{
  return Mint::_Mtemp.apower(x,n,p) ;
}

//
//  compute square
//  faster than multiplication a*a for large a
//
inline Mint square(const Mint& a)
{
  return Mint::_Mtemp.isSquare(a) ;
}

inline long sqrt(const Mint& a,const long p)
{
  return sqrt(a%p,p) ;
}

inline unsigned long sqrt(const Mint& a,const unsigned long p)
{
  return sqrt(mod(a,p),p) ;
}

/****
inline Mint AND(const Mint& a,const Mint& c)
{
  return Mint::_Mtemp.isAND(a,c) ;
}
inline Mint OR(const Mint& a,const Mint& c)
{
  return Mint::_Mtemp.isOR(a,c) ;
}
inline Mint XOR(const Mint& a,const Mint& c)
{
  return Mint::_Mtemp.isXOR(a,c) ;
}
****/
//
//  the highest power of 2 dividing N  (valuation at prime 2)
//
//   2^Val2(N) | N  but not 2^(Val2(N)+1) | N
//
inline int Val2(const Mint& N)
{
  return ::BitScanForward(N.digit,N.nDigit) ;
}

inline Mint factorial(unsigned long n)
{
    return pfactorial(0,n) ;
//  return Mint::_uMtemp.pfactorial(0,n) ;
}

bool Cornacchia(const Mint& d,const Mint& p,Mint& x,Mint& y) ;

// base = 2  Euler 
// true  : probably prime
// false : not prime
inline bool EulerCriterion2(const Mint& n)
{
  return amod(power(Mint(2UL),(n-1)>>1,n),n)==_Kr_tab[long(n)&7] ;
}

//int Combination(unsigned long n,unsigned long k,std::vector<unsigned long>& index,Mint& Cnj);
//int Permutation(unsigned long size,std::vector<unsigned long>& perm,Mint& iseq) ;
void SquarePart(Mint& D,Mint& S,Mint& T,unsigned long MaxPrime=2000000UL) ;
int PrimeDecomp(unsigned long nPrimes,unsigned long* Primes,
                unsigned long* index,Mint& q);

#endif
