//
//  Copyright (C) by S.Tomabechi  1993,1998
//  All rights reversed.
//
//  Polynomial class with coefficients in long integer
//
#ifndef __POLYL_HPP
#define __POLYL_HPP

#include <iostream.h>
#include <iomanip.h>
#include <memory.h>
#include "PolyBase.hpp"
#include "Mint.hpp"
//#include "PolyFp.hpp"


#define isGreater 1
#define isEqual   0
#define isLess    -1

#ifndef __BORLANDC__         // offset of members
#define DEGL (0+4)
#define DIML (4+4)
#define ARYL (8+4)
#endif


//class PolyRL ;
class PolyFp ;
//class PolyRM ;
class PolyL : public PolyBase
{
  friend class PolyRL ;
  friend class PolyFp ;
  friend class PolyRM ;
private:
  PolyL(const int n) ;
public:

  PolyL() ;

  // constructor
  // n is mximal degree
  // second parameter is dummy
  // ̃RXgN^́Aő傎̑\̈mۂ.
  // ̃p^́ÃRXgN^𐮐瑽𐶐
  // RXgN^ƁARpC߂̂W邽߂ŁA̒l
  // QƂȂ.
  PolyL(const int n,int):pArray(NULL)
  {
    allocate(n) ;
    degree=0 ;
  }
                 // copy constructor
  PolyL(const PolyL& f) ;

  ~PolyL() ;

  PolyL& operator=(const PolyL& f) ;
  PolyL& operator=(const PolyFp& f) ; // Wւ̃tg
  PolyL& operator=(const PolyRL f) ;  // d*f[X] in Z[X] Ԃ
  PolyL& operator=(const long c) ;

  PolyL& operator<<=(const int s) ;   // multiply by x^s

  PolyL  operator<<(const int s) ;
  PolyL& operator>>=(const int s) ;   //  divide by x^s


  long operator()(const long x) const ;    // fuction value at x
  Mint operator()(const Mint& x) const ;

  PolyL operator()(const PolyL& f) const ;

  PolyL operator-(void) const ;

  int isZero() ;

  int allocate(int n) ;

  long& operator[](const int index)  ;
  long  operator[](const int index) const { return pArray[index] ; }

  int reallocate(int size) ;


  friend int& deg(PolyL& f) ;
  friend int  deg(const PolyL& f) ;

  friend PolyL& operator+=(PolyL& f,const PolyL& g) ;
  friend PolyL  operator+(const PolyL& f,const PolyL& g) ;
  PolyL&        operator+=(const long c) ;
  PolyL         operator+(const long c) const ;
//  friend PolyL& operator+=(PolyL& f,const long c) ;

//  friend PolyL  operator+(const PolyL& f,const long c) ;

  friend PolyL  operator+(const long c,const PolyL& f) ;

//  friend PolyL& operator-=(PolyL& f,const PolyL& g) ;
  PolyL& operator-=(const PolyL& f) ;
  PolyL  operator-(const PolyL& f) const ;
//  friend PolyL  operator-(const PolyL& f,const PolyL& g) ;

  PolyL& operator-=(const long c) ;
  PolyL operator-(const long c) const ;
//  friend PolyL  operator-(const PolyL &f,const long c) ;
  friend PolyL  operator-(const long c,const PolyL &f) ;

  PolyL& operator*=(const PolyL& f) ;
  PolyL& operator*=(const long c) ;
  PolyL& operator*=(const int c) ;
  PolyL  operator*(const PolyL& f) const ;
  PolyL  operator*(const long c) const ;
  PolyL  operator*(const int c) const ;

  friend PolyL operator*(const long c,const PolyL& f) ;

  friend PolyL operator/(const PolyL& a,const PolyL& b) ;

  friend PolyL& operator/=(PolyL& f,const long c) ;
  friend PolyL operator/(const PolyL& f,const long c) ;

  friend PolyL& operator/=(PolyL& a,const PolyL& b) ;

  PolyL& operator%=(const PolyL& b) ;

  bool operator==(const PolyL& f) ;
  bool operator==(const long c) ;
  bool operator==(const int c) ;
//  friend int operator==(const PolyL& f,const PolyL& g) ;

//  friend int operator==(const PolyL& f,const long c) ;
//  friend int operator==(const PolyL& f,const int c) ;

  bool operator!=(const PolyL& f) ;
//  friend int operator!=(const PolyL& f,const PolyL& g) ;
  bool operator!=(const long c) ;
  bool operator!=(const int c) ;
//  friend int operator!=(const PolyL& f,const int c) ;

  friend int operator<(PolyL& f,int n) { return 1 ; }
  friend int operator>(PolyL& f,int n) { return 1 ; }

  friend PolyL mod(PolyL& a,PolyL& b) ;

  friend PolyL mod(PolyL& f,long c) ;

  friend PolyL D(PolyL& f) ;   // derivative

  friend ostream& operator<<(ostream& os,const PolyL& f) ;
  friend void divide(const PolyL& f,const PolyL& g,
                     PolyL& q,PolyL& r,
                     long& d) ;

  friend PolyL mod(PolyL& a,PolyL& b) ;
  friend PolyL mod(PolyL& a,long c) ;
  friend PolyL amod(PolyL& a,long c) ;

  friend PolyL gcd(PolyL a,PolyL b) ;
  friend PolyL gcdResult(PolyL& a,PolyL& b) ;

  friend PolyL egcd(PolyL& a,PolyL& b,
                    PolyL& u,PolyL& v,
                    long& t) ;

  friend long cont(PolyL& f) ;
  friend PolyL pp(PolyL& f) ;
  friend PolyFp modp(PolyL& f,long p) ;
  friend PolyFp amodp(PolyL& f,long p) ;
//  friend PolyL ZL(PolyFp& f) ;       // lift to Z[X]

  friend PolyL power(const PolyL& f,unsigned long n) ;
  PolyL operator^(const unsigned long n) const ;            // p Zq̗D揇͒Ⴂ̂Œӂ̂

//  friend ostream& operator<<(ostream& os,const PolyL f) ;
  friend istream& operator>>(istream& is,PolyL& f) ;
protected:
//public:
  PolyL& isAdd(const PolyL& a,const PolyL& b) ;
  PolyL& isSub(const PolyL& a,const PolyL& b) ;
  PolyL& isMul(const PolyL& f,const PolyL& g) ;
  PolyL& isMul(const PolyL& f,const long c) ;

  int compare(const PolyL& f) const ;

  PolyL& isShiftr(const PolyL& f,const int s) ;
  PolyL& isShiftl(const PolyL& f,const int s) ;

protected:
//public:
  int degree ;
  int nDim ;
  long* pArray ;
  static PolyL _Ptemp ;
  static PolyL _uPtemp ;
public:
  static const PolyL X ;

  PolyL& normalize() ;

} ;



inline long& PolyL::operator[](const int index)
{
  return pArray[index] ;
}

inline PolyL& operator+=(PolyL& f,const PolyL& g)
{
  return f.isAdd(f,g) ;
}

inline PolyL operator+(const PolyL& f,const PolyL& g)
{
  return (PolyL::_Ptemp).isAdd(f,g) ;
}

inline PolyL& PolyL::operator-=(const PolyL& f)
{
  return isSub(*this,f) ;
}

inline PolyL& PolyL::operator-=(const long c)
{
  return operator+=(-c) ;
}

inline PolyL PolyL::operator-(const PolyL& f) const
{
  return (PolyL::_Ptemp).isSub(*this,f) ;
}

inline PolyL& PolyL::operator*=(const PolyL& f)
{
  return isMul(*this,f) ;
}

inline PolyL& PolyL::operator*=(const long c)
{
  return isMul(*this,c) ;
}

inline PolyL PolyL::operator*(const long c) const
{
  return _Ptemp.isMul(*this,c) ;
//  return (PolyL::_Ptemp=*this).operator*=(c) ;
}

inline PolyL operator*(const long c,const PolyL& f)
{
  return PolyL::_Ptemp.isMul(f,c) ;
//  return (PolyL::_Ptemp=*this).operator*=(c) ;
}


inline PolyL PolyL::operator*(const PolyL& f) const
{
  return _Ptemp.isMul(*this,f) ;
}

inline bool PolyL::operator==(const PolyL& f)   // comparison
{
  return compare(f)==isEqual ;
}

inline bool PolyL::operator==(const long c)
{
  return degree==0 && *pArray==c ;
}

inline bool PolyL::operator==(const int c)
{
  return operator==(long(c)) ;
}

inline bool PolyL::operator!=(const PolyL& f)   // comparison
{
  return !operator==(f) ;
}

inline bool PolyL::operator!=(const long c)
{
  return !operator==(c) ;
}

inline bool PolyL::operator!=(const int c)
{
  return operator!=(long(c)) ;
}

inline int isZero(PolyL& f)
{
  return f.isZero() ;
}

long resultant(PolyL a,PolyL b) ;

inline PolyL PolyL::operator^(const unsigned long n) const      // power f(x)^n
{
  return power(*this,n) ;
}

inline PolyL PolyL::operator+(const long c) const    // add constant
{
  return (_Ptemp=*this)+=c ;
}

inline PolyL PolyL::operator-(const long c) const   // subtract constant
{
  return (_Ptemp=*this)-=c ;
}

inline int& deg(PolyL& f)               // degree of polynomial
{
  return f.degree ;
}

inline int deg(const PolyL& f)          // degree of polynomial
{
  return f.degree ;
}
#endif
