//
//  Copyright (C) by S.Tomabechi 1994,1996
//  All rights reserved.
//
//  Prime Decomposition by Elliptic Curve Method
//
//  ̃vOł́AؓcSiɂ UBASIC ̃\[XQlɂD
//
//  1997/08/06  肽͂ȂÂ private ֐gD
//
//  duplicate
//    (x_2n:z_2n)=(x_n^2+y_n^2:4x_n*y_n*{x_n^2+a*x_n*y_n*y_n^2})
//

/***************
pvO GMP-ECM 
    http://www.loria.fr/~zimmerma/records/ecmnet.html
ɓ邱Ƃo܂B
ȉ~Ȑ by^2 = x^3 + ax^2 + x mod p , _ (x1:y1:z1) ,
ȉ~Ȑԍ sigma ƂƁA
GMP-ECM ł
        u=sigma^2-5, v=4*sigma
        x1=u^3, z1=v^3
        a=(v-u)^3*(3*u+v)/(4*u^3*v)-2
ƂČvZĂ܂B
UBASIC Yt ECMX.UB ł
        u=2*(sigma+1)/(3*(sigma+1)^2-1)
        x1=3*u^2+1, z1=4*u
        a=(-3*u^4-6*u+1)/(4*u^3)
ƂČvZĂ܂B
ȊÕp[^ƂĂ
        u=6*sigma/(sigma^2+6)
        x1=3*u, z1=4
        a=(-3*u^4-6*u+1)/(4*u^3)
l܂B
*****************/

#include "Mint.hpp"
#include "Fint.hpp"
#include <math.h>
#include "Error.hpp"
#include <time.h>
#ifdef __BORLANDC__
#include <constrea.h>
#endif
//#include <conio.h>

extern bool display_ECM=false ;

Mint& irandom(Mint& s,const Mint& max) ;
//extern constream con ;
//
//  N     (I) fׂ
//  itry  (I) ȉ~Ȑ̌
//
Mint ecm(const Mint& N,int itry,unsigned long maxL1)
{
  Mint aa ;
  int j,k ;
  unsigned long p,q ;
  int deg ;
  Mint a0,a2 ; // a2 is used as a0*a0
  Mint u,v ;
  Mint a ;
  Mint x,z,w1,w2 ;
  Mint xzp,xzm ;
  Mint GD ;
  Mint ux,uz,dx,dz ;
  Mint tx,tz,wx,wz ;
  Mint x1,x2,x3,x4 ;
  Mint wp,wm,ww ;
  bool coprime[211] ;
  if (display_ECM ) {
    cout << endl << "ECM       " << N ;
  }
  unsigned long L1 ;
//  L1=(unsigned long)(1400*exp((log((long double)isqrt(N))-31.0)*0.14))+100 ;
//cout << endl << isqrt(N) ;
//cout << endl << log((double)isqrt(N)) ;
//cout << endl << log(Fint(isqrt(N))) ;
//  L1=(unsigned long)(1400*exp((log((double)isqrt(N))-31.0)*0.14))+100 ;
//cout << endl << "L1 " << L1 ;

    if( len10(N)<100 )
      L1=(unsigned long)(1400*exp((log((long double)isqrt(N))-31.0)*0.14))+100 ;
    else L1=SMALL_DIVISOR ;


//  L1=SMALL_DIVISOR<L1 ? SMALL_DIVISOR:L1 ;
//  L1=10000000UL<L1 ? 10000000UL:L1 ;
  if( maxL1==0 ) maxL1=1000000UL ;
//cout << endl << maxL1 ;
#if 0
  L1=maxL1<L1 ? maxL1:L1 ;
#else
  L1=maxL1 ;
#endif
//cout << endl << L1 ;
//  if( L1<500000UL ) L1=500000UL ;

  double L2=100*double(L1) ;
//  Mint L2=Mint(L1)*40 ;
//cout << endl << (L2>>32) ;
//  if( (L2>>32)>=420 ) (L2=400)<<=32 ;
//  unsigned long L22=(unsigned long)(L2/420) ;
//L1=300000 ;
//L2=100*L1 ;
  double L22=L2/420 ;
  double LG=log(L1) ;
  double qd ;
  double log2=log(2.0) ;
  Mint* F=new Mint[49] ;
  if( !F ) Error( polynomial allocate error) ;
  if (display_ECM ) {
    cout << endl << "L1 " << L1 ;
    cout << endl << "L2 " << L2 << flush ;
  }


  for( j=5 ; j<=210 ; j+=5 ) {
    if( gcd((unsigned long)j,210UL)==1 ) coprime[j]=true ;
    else                      coprime[j]=false ;
  }

//  static unsigned long ec(12345) ;
  unsigned long ec=(long)time(NULL) ;
  Mint s(ec) ;
  s[N.ndigit()] ;

  for( ; itry>0 ; itry-- ) {
//    a=irandom(s,N)+1 ;
    ec=irandom(ec) ;
    a=ec+1 ;
/*************
    a0=mod(a*a-5,N) ;       // u=a^2-5
    a2=a<<2 ;               // v=4*a
    x=mod(a0*a0*a0,N) ;       // x=u^3
    z=mod(a2*a2*a2,N) ;       // z=v^3
    a=x-z-3*a0*a2*(a0-a2) ;    // a<- (u-v)^3
    a*=(3*a0+a2) ;
    ((a*=invmodp(4*x*a2,N))-=2)&=N ;     //
    aa=mod((a+2)*invmodp(Mint(4),N),N) ;      // aa=(a+2)/4
*********/
/***************/
    a0=mod(2*a*invmodp(3*a*a-1,N),N) ;
    a2.isMul(a0,a0)%=N ; //    a2=mod(a0*a0,N) ;
    if( mod(a0*(a2-1)*(9*a2-1),N)==0 ) continue ;
    a=mod(mod((-3*a2*a2-6*a2+1),N)*invmodp(4*a2*a0,N),N) ;
    aa=mod((a+2)*invmodp(Mint(4),N),N) ;      // aa=(a+2)/4
    x=mod(3*a2+1,N) ;
    z=mod(4*a0,N) ;
/***************/
  if (display_ECM ) {

    cout << endl << "a " << a ;
    cout << " sigma " << (ec+1) ;
    cout << " x,z " << x << " " << z << flush ;
  }

    // 1-st step
    // for power of 2
    j=LG/log2 ;
      // calculate P_{2n} <- P_n+P_n
    for( ; j>0 ; j-- ) {
      w1.isSquare(x+z)%=N ;  // w1=mod((x+z)*(x+z),N) ; // x^2+z^2+2xz
//      w1.isSquare(x+z) ;  // w1=mod((x+z)*(x+z),N) ; // x^2+z^2+2xz
      w2.isSquare(x-z)%=N ;  // w2=mod((x-z)*(x-z),N) ; // x^2+z^2-2xz
//      w2.isSquare(x-z) ;  // w2=mod((x-z)*(x-z),N) ; // x^2+z^2-2xz
      x.isMul(w1,w2)%=N ;    // x=mod(w1*w2,N) ;   // x=(x^2-z^2)^2
      ww.isSub(w1,w2) ;      // z=mod((w1-w2)*mod(w2+aa*(w1-w2),N),N)  ;
                             //ww=4*x*z
                             // 4*aa=a+2
//      w2+=aa*ww ;            // w2=(x^2+z^2-2xz)+aa*4*x*z=(x^2+z^2-2xz)+(a+2)xz=x^2+z^2+axz
      w1.isMul(aa,ww)%=N ;
      w2+=w1 ;
      z.isMul(ww,w2)%=N ;    // z=4xz*(x^2+z^2+axz)
    }

    GD.isGCD(z,N) ;
    if( GD>1 && GD!=N ) goto Find ;
    for( p=2 ; p<=L1 ;) {
if( kbhit() ) {
  while( kbhit() ) getch() ;
  goto Failed ;
}
      p=nextprm(p) ;
      j=LG/log(p) ;
      for( ; j>0 ; j-- ) {
        tx=x ; tz=z ; ux=x ; uz=z ;
        x3.isAdd(tx,tz) ;     // x3=tx+tz ;
        x4.isSub(tx,tz) ;     // x4=tx-tz ;
        k=ilog2(p) ;
        q=1 ;
        for( ; k>0 ; k-- ) {
          x1.isSquare(x3)%=N ;
//          x1.isMul(x3,x3)%=N ;  // x1=mod(x3*x3,N) ;
          x2.isSquare(x4)%=N ;
//          x2.isMul(x4,x4)%=N ;  // x2=mod(x4*x4,N) ;
          tx.isMul(x1,x2)%=N ;  // tx=mod(x1*x2,N) ;
          wm.isSub(x1,x2) ;     // wm=x1-x2 ;
//          tz=mod(wm*mod(x2+aa*wm,N),N) ;
          tz=mod(wm*(x2+aa*wm),N) ;
          x3.isAdd(tx,tz) ;     // x3=tx+tz ;
          x4.isSub(tx,tz) ;     // x4=tx-tz ;
          q<<=1 ;
          if( p&q ) {
            x1.isMul(x4,ww.isAdd(x,z))%=N ; // x1=mod(x4*(x+z),N) ;
            x2.isMul(x3,ww.isSub(x,z))%=N ; // x2=mod(x3*(x-z),N) ;
            wp.isAdd(x1,x2) ;               // wp=x1+x2 ;
            wm.isSub(x1,x2) ;               // wm=x1-x2 ;
            x.isMul(ww.isMul(wp,wp),uz)%=N ;
            z.isMul(ww.isMul(wm,wm),ux)%=N ; // z=mod(mod(wm*wm,N)*ux,N) ;
          }
          else {
            x1.isMul(x4,ww.isAdd(ux,uz))%=N ; // x1=mod(x4*(ux+uz),N) ;
            x2.isMul(x3,ww.isSub(ux,uz))%=N ; // x2=mod(x3*(ux-uz),N) ;
            wp.isAdd(x1,x2) ;                 // wp=x1+x2 ;
            wm.isSub(x1,x2) ;                 // wm=x1-x2 ;
            ux.isMul(ww.isMul(wp,wp),z)%=N ; // ux=mod(mod(wp*wp,N)*z,N) ;
            uz.isMul(ww.isMul(wm,wm),x)%=N ; // uz=mod(mod(wm*wm,N)*x,N) ;
          }
        }

      }
      GD.isGCD(z,N) ;
      if( GD>1 && GD!=N ) goto Find ;
    }
//cout << endl << "failed 1-st step" ;

leave_Mainloop: ;

    // 2nd_step
    // make polynomial
    ux=x ; uz=z ;   // =R
    deg=1 ;
    F[1]=1 ;
    F[0]=mod(-x*invmodp(z,N),N) ;
    xzp.isAdd(x,z) ;
//    w1.isSquare(x+z)%=N ; // w1=mod((x+z)*(x+z),N) ;
    w1.isSquare(xzp)%=N ;
    xzm.isSub(x,z) ;
//    w2.isSquare(x-z)%=N ; // w2=mod((x-z)*(x-z),N) ; // =2R
    w2.isSquare(xzm)%=N ;
    tx.isSquare(w1)%=N ;
//    tx.isMul(w1,w2)%=N ;  // tx=mod(w1*w2,N) ;
    wm.isSub(w1,w2) ;     // wm=w1-w2 ;
    tz=mod(wm*(w2+aa*wm),N) ;
//    w1=mod((x-z)*(tx+tz),N) ;
    w1=mod(xzm*(tx+tz),N) ;
//    w2=mod((x+z)*(tx-tz),N) ;
    w2=mod(xzp*(tx-tz),N) ;
    wp.isAdd(w1,w2) ;    // wp=w1+w2 ;
    wm.isSub(w1,w2) ;    // wm=w1-w2 ;
//    x.isMul(ww.isMul(wp,wp)%=N,uz)%=N ;  // x=mod(mod(wp*wp,N)*uz,N) ;
//    z.isMul(ww.isMul(wm,wm)%=N,ux)%=N ;  // z=mod(mod(wm*wm,N)*ux,N) ;
    x.isMul(ww.isMul(wp,wp),uz)%=N ;  // x=mod(mod(wp*wp,N)*uz,N) ;
    z.isMul(ww.isMul(wm,wm),ux)%=N ;  // z=mod(mod(wm*wm,N)*ux,N) ;
    for( j=5 ; j<=210 ; j += 2 ) {
      wx=x ;
      wz=z ;
      w1=mod((x-z)*(tx+tz),N) ;
      w2=mod((x+z)*(tx-tz),N) ;
      wp.isAdd(w1,w2) ;                   // wp=w1+w2 ;
      wm.isSub(w1,w2) ;                   // wm=w1-w2 ;
      x.isMul(ww.isMul(wp,wp),uz)%=N ; // x=mod(mod(wp*wp,N)*uz,N) ;
      z.isMul(ww.isMul(wm,wm),ux)%=N ; // z=mod(mod(wm*wm,N)*ux,N) ;
      if( j==105 ) { dx=x ; dz=z ; }      // =105R
      if( coprime[j] ) {
        deg++ ;
        wp=mod(-x*invmodp(z,N),N) ;
        F[deg]=1 ;
        for( k=deg-1 ; k>=1 ; k-- ) {
          ((F[k]*=wp)+=F[k-1])&=N ; // F[k]=mod((F[k]*wp+F[k-1]),N) ;
        }
        (F[0]*=wp)&=N ;             // F[0]=mod(F[0]*wp,N) ;
      }
      Swap(ux,wx) ;
      Swap(uz,wz) ;
    }

    wp.isAdd(dx,dz) ;        // wp=dx+dz ;
    wm.isSub(dx,dz) ;        // wm=dx-dz ;
//    w1.isMul(wp,wp)%=N ;     // w1=mod(wp*wp,N) ;
//    w2.isMul(wm,wm)%=N ;     // w2=mod(wm*wm,N) ;
    w1.isSquare(wp)%=N ;
//    w1.isMul(wp,wp) ;     // w1=mod(wp*wp,N) ;
    w2.isSquare(wm)%=N ;
//    w2.isMul(wm,wm) ;     // w2=mod(wm*wm,N) ;
    x.isMul(w1,w2)%=N ;      // x=mod(w1*w2,N) ;
                      // z=mod((w1-w2)*mod(w2+aa*(w1-w2),N),N) ;
    wm.isSub(w1,w2) ;
    z=mod(wm*(w2+aa*wm),N);
    ux=x ;
    uz=z ;
    wp.isAdd(x,z) ; //    wp=x+z ;
    wm.isSub(x,z) ; //    wm=x-z ;
    w1.isSquare(wp)%=N ;
//    w1.isMul(wp,wp)%=N ; //    w1=mod(wp*wp,N) ;
    w2.isSquare(wm)%=N ;
//    w2.isMul(wm,wm)%=N ; //    w2=mod(wm*wm,N) ;
    tx.isMul(w1,w2)%=N ; //    tx=mod(w1*w2,N) ;
    wm.isSub(w1,w2) ;    //    wm=w1-w2 ;
//    tz=mod(wm*mod(w2+aa*wm,N),N) ;
    tz=mod(wm*(w2+aa*wm),N) ;
    w1=mod((x-z)*(tx+tz),N) ;
    w2=mod((x+z)*(tx-tz),N) ;
    wp.isAdd(w1,w2) ; //    wp=w1+w2 ;
    wm.isSub(w1,w2) ; //    wm=w1-w2 ;
    x.isMul(ww.isSquare(wp)%=N,uz)%=N ; //    x=mod(mod(wp*wp,N)*uz,N) ;
//    x.isMul(ww.isMul(wp,wp),uz)%=N ; //    x=mod(mod(wp*wp,N)*uz,N) ;
    z.isMul(ww.isSquare(wm)%=N,ux)%=N ; //    z=mod(mod(wm*wm,N)*ux,N) ;
//    z.isMul(ww.isMul(wm,wm),ux)%=N ; //    z=mod(mod(wm*wm,N)*ux,N) ;

    for( qd=2 ; qd<=L22 ; qd+=1 ) {

if( kbhit() ) {
  while( kbhit() ) getch() ;
  goto Failed ;
}
      x1.isMul(x,ww.isInvModp(z,N))%=N ; //      x1=mod(x*invmodp(z,N),N) ;
      x2.isSquare(x1)%=N ;
//      x2.isMul(x1,x1)%=N ; //      x2=mod(x1*x1,N) ;
      x3.isMul(x1,x2)%=N ; //      x3=mod(x1*x2,N) ;
      x4.isSquare(x2)%=N ;
//      x4.isMul(x2,x2)%=N ; //      x4=mod(x2*x2,N) ;
      w1=1 ;
      for( j=47 ; j>=0 ; j-=4 ) {
        w1=mod(w1*x4+F[j]*x3+F[j-1]*x2+F[j-2]*x1+F[j-3],N) ;
      }
      GD.isGCD(w1,N) ;
      if( GD>1 && GD!=N ) goto Find ;
      wx=x ;
      wz=z ;
      w1=mod((x-z)*(tx+tz),N) ;
      w2=mod((x+z)*(tx-tz),N) ;
      wp.isAdd(w1,w2) ; //      wp=w1+w2 ;
      wm.isSub(w1,w2) ; //      wm=w1-w2 ;
      x.isMul(ww.isSquare(wp)%=N,uz)%=N ; //      x=mod(wp*mod(wp*uz,N),N) ;
//      x.isMul(ww.isMul(wp,wp),uz)%=N ; //      x=mod(wp*mod(wp*uz,N),N) ;
      z.isMul(ww.isSquare(wm)%=N,ux)%=N ; //      z=mod(wm*mod(wm*ux,N),N) ;
//      z.isMul(ww.isMul(wm,wm),ux)%=N ; //      z=mod(wm*mod(wm*ux,N),N) ;
      Swap(ux,wx) ;
      Swap(uz,wz) ;
    }
  }
Failed:
  GD=1 ;
Find: ;
RET:
  delete [] F ;
  return GD ;
}


